/**
 * Copyright 2011 Nikolche Mihajlovski
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jannocessor.adapter.type;

import javax.lang.model.type.PrimitiveType;
import javax.lang.model.util.Elements;
import javax.lang.model.util.Types;

import org.jannocessor.collection.api.PowerList;
import org.jannocessor.model.CodeNode;
import org.jannocessor.model.type.JavaPrimitiveType;
import org.jannocessor.model.util.ModelUtils;

public class JavaPrimitiveTypeAdapter extends AbstractJavaTypeAdapter implements
		JavaPrimitiveType {

	private static final long serialVersionUID = -6097262015623615699L;
	@SuppressWarnings("unused")
	private final PrimitiveType primitiveType;

	public JavaPrimitiveTypeAdapter(PrimitiveType primitiveType,
			Elements elementUtils, Types typeUtils) {
		super(primitiveType, elementUtils, typeUtils);

		this.primitiveType = primitiveType;

	}

	@Override
	protected Class<? extends JavaPrimitiveType> getAdaptedInterface() {
		return JavaPrimitiveType.class;
	}

	@Override
	public PowerList<CodeNode> getChildren() {
		return ModelUtils.getChildren(this);
	}

	@Override
	public JavaPrimitiveType copy() {
		throw calculatedMethodException();
	}

}
